<template>
	<div class="sample-form">
		<v-card-title class="px-0 d-flex align-start justify-space-between">
			<div>Sample</div>
			<div class="text-body-2">
				<div v-if="location.properties.label">Location: {{ location.properties.label }}</div>
				<div v-if="location.properties.stratum">Stratum: {{ location.properties.stratum }}</div>
				<div v-if="location.properties.composite">Composite: {{ location.properties.composite }}</div>
				<div v-if="location.properties.bulkDensityRequired" class="text-body-2">Bulk Density Required</div>
			</div>
		</v-card-title>
		<v-form @submit="onSubmit" ref="sampleForm" v-model="isValidForm">
			<div class="d-flex align-center">
				<v-text-field
					label="Label (Bag ID)"
					v-model="label"
					:rules="[(val) => (val && val.length > 3 ? true : 'Label must be at least 4 characters')]"
				/>
				<qr-scanner @codeDetected="onCodeDetected" />
			</div>
			<v-select
				label="Depth"
				:items="depths"
				v-model="depthSelectValue"
				@input="onDepthSelect"
				:rules="[
					(val) => (val && depth.minValue && depth.maxValue ? true : 'Depth is required'),
					(val) =>
						val && depth.minValue && depth.maxValue && depth.maxValue.value > depth.minValue.value
							? true
							: 'Max depth must be greater than min depth',
					(val) => (val && depth.minValue && depth.minValue.value >= 0 ? true : 'Min depth must be greater than zero'),
				]"
			/>
			<depths-form v-if="depthSelectValue === 'custom'" single :items="[depth]" @setDepths="onSetDepths" />
			<div class="d-flex justify-end">
				<v-btn @click="onDelete" class="px-4" v-if="sample" text rounded color="error"> Delete </v-btn>
				<v-btn @click="onCancel" class="px-4" text rounded> Cancel </v-btn>
				<v-btn @click="onSubmit" class="px-4" rounded color="primary" :disabled="!isValidForm">
					{{ sample ? 'Update' : 'Add' }}
				</v-btn>
			</div>
		</v-form>
	</div>
</template>

<script lang="ts">
import { defineComponent, computed, ref, watch, onMounted } from '@vue/composition-api';
import { Sample, Sampling, SamplingCollection, SoDepth, Location } from '@/store/types';
import ObjectId from 'bson-objectid';
import DepthsForm from '@/components/forms/DepthsForm/DepthsForm.vue';
import QRScanner from '@/components/qr-scanner/QRScanner.vue';

function createSoDepth() {
	return {
		minValue: {
			value: 0,
			unit: 'unit:CM',
		},
		maxValue: {
			value: 0,
			unit: 'unit:CM',
		},
	};
}

export default defineComponent({
	components: {
		DepthsForm,
		'qr-scanner': QRScanner,
	},
	props: {
		sample: {
			type: Object as () => Sample,
		},
		sampling: {
			type: Object as () => Sampling,
		},
		samplingCollection: {
			type: Object as () => SamplingCollection,
		},
		location: {
			type: Object as () => Location,
		},
	},
	setup(props, { emit }) {
		const label = ref('');
		const depth = ref();
		const depthSelectValue = ref();
		const sampleForm = ref();
		const isValidForm = ref();

		function onDepthSelect(val: string | SoDepth) {
			if (val === 'custom') {
				depth.value = createSoDepth();
			} else if (typeof val !== 'string') {
				depth.value = val;
			}
		}

		const depths = computed(() => {
			const items =
				props.samplingCollection?.sampleDepths.map((d: SoDepth) => ({
					text: `${d.minValue.value} - ${d.maxValue.value} cm`,
					value: d,
				})) || [];
			return [
				...items,
				{
					text: 'Custom',
					value: 'custom',
				},
			];
		});

		function initialize(sample: Sample | undefined) {
			label.value = sample?.name || '';
			depth.value = sample?.soDepth || undefined;

			const depthIsStandard = props.samplingCollection?.sampleDepths.some(
				(d: SoDepth) =>
					d.maxValue.value === sample?.soDepth.maxValue.value && d.minValue.value === sample?.soDepth.minValue.value
			);

			if (sample && depthIsStandard) {
				depthSelectValue.value = sample.soDepth;
			} else if (sample && !depthIsStandard) {
				depthSelectValue.value = 'custom';
				depth.value = sample.soDepth;
			} else {
				depthSelectValue.value = undefined;
			}
			sampleForm.value.resetValidation();
		}

		onMounted(() => {
			initialize(props.sample);
		});

		watch(
			() => props.sample,
			(sample) => initialize(sample)
		);

		function onSubmit() {
			if (sampleForm.value.validate()) {
				// TODO: validate sample
				const newSample = {
					id: props.sample?.id || new ObjectId().toHexString(),
					name: label.value,
					resultOf: props.sampling?.id,
					soDepth: { ...depth.value },
				};
				emit('setSample', newSample);
				sampleForm.value.reset();
			}
		}

		function onSetDepths(depths: SoDepth[]) {
			depth.value = depths[0];
			sampleForm.value.validate();
		}

		function onCancel() {
			emit('cancelSample');
			sampleForm.value.reset();
		}

		function onDelete() {
			emit('deleteSample', props.sample?.id);
			sampleForm.value.reset();
		}

		function onCodeDetected(val: string) {
			label.value = val;
		}

		return {
			depths,
			onSubmit,
			onDepthSelect,
			depth,
			depthSelectValue,
			label,
			createSoDepth,
			onSetDepths,
			sampleForm,
			onCancel,
			onDelete,
			onCodeDetected,
			isValidForm,
		};
	},
});
</script>

<style></style>
